////////////////////////////////////////////////////////////////////////////////
//
//
//   Author       : Bogdan Popescu
//   Organization : University of Cincinnati
//   Program      : goccm2
//   Version      : 2.014
//   Date         : Dec 10, 2014
//   Tested       : g++ 4.6.3 x64 (Ubuntu 12.04 LTS x64)
//                  g++ 4.8.2 x64 (Ubuntu 14.04 LTS x64)     
//                    
//                  
//
////////////////////////////////////////////////////////////////////////////////
//
//    MASSCLEAN (MASSive CLuster Evolution and ANalysis Package)
//    Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON
//
//    goccm2.cc is part of MASSCLEAN.
//
//    MASSCLEAN is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    MASSCLEAN is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with MASSCLEAN; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//    or go to : http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////////



#include <iostream>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <ctype.h> 
#include <iomanip> 

#include <cstdlib> 
#include <ctime>   

#include <sys/time.h>  
#include <time.h>
#include <unistd.h>



using namespace std;



///////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
///////////
///////////  MAIN PROGRAM
///////////
//////////////////////////////////////////////////////////////////////////////////

int main()
{
   cout << "\n";


  cout <<"MASSCLEAN 2.014 (MASSive CLuster Evolution and ANalysis Package)"<<"\n";

  cout <<"Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON,"<<"\n";

  cout <<"under GNU General Public License. For details see 'COPYING'."<<"\n";

  cout <<"The program 'goCCM2' is part of MASSCLEAN 2.014 CC (Clever Crocodile)."<<"\n";

  cout << "\n";
  cout <<"http://massclean.org/"<< '\n';
  cout <<"http://bogdan.massclean.org/"<< '\n';

  cout << "\n";


  cout <<"Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  cout <<"Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  cout <<"Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';


  cout << "\n";
  cout << "\n";





double x,y,i,j,k,xx,yy;
double R_V, A_V;
double a,b,aa,bb;
double lambda_U,lambda_B,lambda_V,lambda_R,lambda_I,lambda_J,lambda_H,lambda_K;
double mass,dd,FOV,WIDTH,HEIGHT,WIDTH_CCD,HEIGHT_CCD,secz,A_U,A_B;
int ccm_on_off;
int VERBOSE;
double VISTAZ,VISTAY,VISTAJ,VISTAH,VISTAKS;

_chdir("ini.files");

ifstream clusterfile;
clusterfile.open("cluster.ini");

  if (clusterfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (clusterfile.peek()=='#') { clusterfile.ignore(300,'\n');}

clusterfile >> VERBOSE; clusterfile.ignore(300,'\n');
clusterfile >> mass; clusterfile.ignore(300,'\n');
clusterfile >> dd; clusterfile.ignore(300,'\n');
clusterfile >> FOV; clusterfile.ignore(300,'\n');
clusterfile >> WIDTH; clusterfile.ignore(300,'\n');
clusterfile >> HEIGHT; clusterfile.ignore(300,'\n');
clusterfile >> WIDTH_CCD; clusterfile.ignore(300,'\n');
clusterfile >> HEIGHT_CCD; clusterfile.ignore(300,'\n');
clusterfile >> ccm_on_off; clusterfile.ignore(300,'\n');
clusterfile >> R_V; clusterfile.ignore(300,'\n');
//clusterfile >> secz; clusterfile.ignore(300,'\n');
clusterfile >> A_U; clusterfile.ignore(300,'\n');
clusterfile >> A_B; clusterfile.ignore(300,'\n');
clusterfile >> A_V; clusterfile.ignore(300,'\n');

clusterfile.close();


  int headonoff;  


  ifstream data13("header.ini");

  if (data13.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data13.peek()=='#') { data13.ignore(300,'\n');}

  data13 >> headonoff; 
  data13.ignore(300,'\n');

  data13.close();



//cout << "Reading file filters.dat ...";
//cout <<"... done !" <<'\n';

_chdir("..");




_chdir("data"); 

ofstream filtersout("ccmfilters.out");

if (headonoff==1)
{

  filtersout <<"##  "<< '\n';
  filtersout <<"##  MASSCLEAN 2.014 Clever Crocodile"<< '\n';
  filtersout <<"##  B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  filtersout <<"##  http://massclean.org/"<< '\n';

  filtersout <<"##  "<< '\n';

  filtersout <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  filtersout <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  filtersout <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  filtersout <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  filtersout <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  filtersout <<"##  "<< '\n';



filtersout << "# A(lambda)    lambda (nanometers) "<<'\n';
filtersout <<"##  "<< '\n';
}
/*
ofstream plotccmfile("plotccm.gpl");

  plotccmfile <<"##  "<< '\n';
  plotccmfile <<"## B.Popescu and M.M.Hanson, 2007-2009 "<< '\n';
  plotccmfile <<"##  "<< '\n';
  plotccmfile <<"##  plotccm.gpl"<< '\n';
  plotccmfile <<"##  "<< '\n';
  plotccmfile <<"set terminal postscript enhanced"<< '\n';
  plotccmfile <<"## "<< '\n';
  plotccmfile <<"##  "<< '\n';
  plotccmfile <<"  "<< '\n';

plotccmfile <<"set output 'ccm_extinction.eps'"<<'\n';
plotccmfile <<"set nokey"<<'\n';
plotccmfile <<"set xrange [300:3500]"<<'\n';
plotccmfile << "set xlabel \" {/Symbol l} (nm) \""<<'\n';
plotccmfile << "set ylabel \" A({/Symbol l}) (mag) \""<<'\n';
*/


for (i=0;i<=10000;i++)

{
x=0.3+i/10000.*3.3;


if ((x>=0.3) && (x<=1.1))

{
a=0.574*pow(x,1.61);
b=-0.527*pow(x,1.61);
}


if ((x>1.1) && (x<=3.3))

{
y=x-1.82;
a=1.+0.17699*y-0.50447*pow(y,2.)-0.02427*pow(y,3.)+0.72085*pow(y,4.)+0.01979*pow(y,5.)-0.77530*pow(y,6.)+0.32999*pow(y,7.);
b=1.41338*y+2.28305*pow(y,2.)+1.07233*pow(y,3.)-5.38434*pow(y,4.)-0.62251*pow(y,5.)+5.30260*pow(y,6.)-2.09002*pow(y,7.);
}


filtersout << setw(8) <<A_V*(a+b/R_V)<<"    "<< setw(8) <<1./x*1000.<<'\n';;
}


cout << "Writing file ccmfilters.out ...";
cout <<"... done !" <<'\n';

_chdir(".."); // 


_chdir("ini.files");
ifstream filterfile;
filterfile.open("filters.dat");

  if (filterfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filterfile.peek()=='#') { filterfile.ignore(300,'\n');}



filterfile >> lambda_U;
filterfile.ignore(300,'\n');

filterfile >> lambda_B;
filterfile.ignore(300,'\n');

filterfile >> lambda_V;
filterfile.ignore(300,'\n');

filterfile >> lambda_R;
filterfile.ignore(300,'\n');

filterfile >> lambda_I;
filterfile.ignore(300,'\n');

filterfile >> lambda_J;
filterfile.ignore(300,'\n');

filterfile >> lambda_H;
filterfile.ignore(300,'\n');

filterfile >> lambda_K;
filterfile.ignore(300,'\n');

filterfile >> VISTAZ;
filterfile.ignore(300,'\n');

filterfile >> VISTAY;
filterfile.ignore(300,'\n');

filterfile >> VISTAJ;
filterfile.ignore(300,'\n');

filterfile >> VISTAH;
filterfile.ignore(300,'\n');

filterfile >> VISTAKS;
filterfile.ignore(300,'\n');


_chdir("..");


_chdir("data"); 

ofstream filters("ccm.filters");

if (headonoff==1)
{

  filters <<"##  "<< '\n';
  filters <<"##  MASSCLEAN 2.014 Clever Crocodile"<< '\n';
  filters <<"##  B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  filters <<"##  http://massclean.org/"<< '\n';

  filters <<"##  "<< '\n';

  filters <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  filters <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  filters <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  filters <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  filters <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  filters <<"##  "<< '\n';
  filters <<"##  ccm.filters"<< '\n';
  filters <<"## " <<'\n';
}
ofstream filters2("ccm.filters.diff");


if ((1./lambda_U>=0.3) && (1./lambda_U<=1.1))

{
aa=0.574*pow(1./lambda_U,1.61);
bb=-0.527*pow(1./lambda_U,1.61);
}

if ((1./lambda_U>1.1) && (1./lambda_U<=3.3))

{
yy=1./lambda_U-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';



if ((1./lambda_B>=0.3) && (1./lambda_B<=1.1))

{
aa=0.574*pow(1./lambda_B,1.61);
bb=-0.527*pow(1./lambda_B,1.61);
}

if ((1./lambda_B>1.1) && (1./lambda_B<=3.3))

{
yy=1./lambda_B-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';




if ((1./lambda_V>=0.3) && (1./lambda_V<=1.1))

{
aa=0.574*pow(1./lambda_V,1.61);
bb=-0.527*pow(1./lambda_V,1.61);
}

if ((1./lambda_V>1.1) && (1./lambda_V<=3.3))

{
yy=1./lambda_V-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';

filters2 << "A_V: "<<A_V<<'\n';


if ((1./lambda_R>=0.3) && (1./lambda_R<=1.1))

{
aa=0.574*pow(1./lambda_R,1.61);
bb=-0.527*pow(1./lambda_R,1.61);
}

if ((1./lambda_R>1.1) && (1./lambda_R<=3.3))

{
yy=1./lambda_R-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';



if ((1./lambda_I>=0.3) && (1./lambda_I<=1.1))

{
aa=0.574*pow(1./lambda_I,1.61);
bb=-0.527*pow(1./lambda_I,1.61);
}

if ((1./lambda_I>1.1) && (1./lambda_I<=3.3))

{
yy=1./lambda_I-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';



if ((1./lambda_J>=0.3) && (1./lambda_J<=1.1))

{
aa=0.574*pow(1./lambda_J,1.61);
bb=-0.527*pow(1./lambda_J,1.61);
}

if ((1./lambda_J>1.1) && (1./lambda_J<=3.3))

{
yy=1./lambda_J-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';




if ((1./lambda_H>=0.3) && (1./lambda_H<=1.1))

{
aa=0.574*pow(1./lambda_H,1.61);
bb=-0.527*pow(1./lambda_H,1.61);
}

if ((1./lambda_H>1.1) && (1./lambda_H<=3.3))

{
yy=1./lambda_H-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';




if ((1./lambda_K>=0.3) && (1./lambda_K<=1.1))

{
aa=0.574*pow(1./lambda_K,1.61);
bb=-0.527*pow(1./lambda_K,1.61);
}

if ((1./lambda_K>1.1) && (1./lambda_K<=3.3))

{
yy=1./lambda_K-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';


if ((1./VISTAZ>=0.3) && (1./VISTAZ<=1.1))

{
aa=0.574*pow(1./VISTAZ,1.61);
bb=-0.527*pow(1./VISTAZ,1.61);
}

if ((1./VISTAZ>1.1) && (1./VISTAZ<=3.3))

{
yy=1./VISTAZ-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';



if ((1./VISTAY>=0.3) && (1./VISTAY<=1.1))

{
aa=0.574*pow(1./VISTAY,1.61);
bb=-0.527*pow(1./VISTAY,1.61);
}

if ((1./VISTAY>1.1) && (1./VISTAY<=3.3))

{
yy=1./VISTAY-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';

double JJ,HH,KK;

if ((1./VISTAJ>=0.3) && (1./VISTAJ<=1.1))

{
aa=0.574*pow(1./VISTAJ,1.61);
bb=-0.527*pow(1./VISTAJ,1.61);
}

if ((1./VISTAJ>1.1) && (1./VISTAJ<=3.3))

{
yy=1./VISTAJ-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';

JJ=A_V*(aa+bb/R_V);

if ((1./VISTAH>=0.3) && (1./VISTAH<=1.1))

{
aa=0.574*pow(1./VISTAH,1.61);
bb=-0.527*pow(1./VISTAH,1.61);
}

if ((1./VISTAH>1.1) && (1./VISTAH<=3.3))

{
yy=1./VISTAH-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';

HH=A_V*(aa+bb/R_V);



if ((1./VISTAKS>=0.3) && (1./VISTAKS<=1.1))

{
aa=0.574*pow(1./VISTAKS,1.61);
bb=-0.527*pow(1./VISTAKS,1.61);
}

if ((1./VISTAKS>1.1) && (1./VISTAKS<=3.3))

{
yy=1./VISTAKS-1.82;
aa=1.+0.17699*yy-0.50447*pow(yy,2.)-0.02427*pow(yy,3.)+0.72085*pow(yy,4.)+0.01979*pow(yy,5.)-0.77530*pow(yy,6.)+0.32999*pow(yy,7.);
bb=1.41338*yy+2.28305*pow(yy,2.)+1.07233*pow(yy,3.)-5.38434*pow(yy,4.)-0.62251*pow(yy,5.)+5.30260*pow(yy,6.)-2.09002*pow(yy,7.);
}
filters << A_V*(aa+bb/R_V)<<'\n';

KK=A_V*(aa+bb/R_V);


filters2 <<"A_J-A_Ks: "<<JJ-KK<<'\n';
filters2 <<"A_J-A_H:  "<<JJ-HH<<'\n';
filters2 <<"A_J:      "<<JJ<<'\n';
filters2 <<"A_H:      "<<HH<<'\n';
filters2 <<"A_Ks:     "<<KK<<'\n';


cout << "Writing file ccm.filters ...";
cout <<"... done !" <<'\n';

filtersout.close();
filters.close();
//filters2.close();



ifstream filterfile2;
filterfile2.open("ccm.filters");

  if (filterfile2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (filterfile2.peek()=='#') { filterfile2.ignore(300,'\n');}

double AU,AB,AV,AR,AI,AJ,AH,AK;
double A1,A2,A3,A4,A5;

filterfile2 >> AU;
filterfile2.ignore(300,'\n');

filterfile2 >> AB;
filterfile2.ignore(300,'\n');

filterfile2 >> AV;
filterfile2.ignore(300,'\n');

filterfile2 >> AR;
filterfile.ignore(300,'\n');

filterfile2 >> AI;
filterfile2.ignore(300,'\n');

filterfile2 >> AJ;
filterfile.ignore(300,'\n');

filterfile2 >> AH;
filterfile.ignore(300,'\n');

filterfile2 >> AK;
filterfile2.ignore(300,'\n');

filterfile2 >> A1;
filterfile2.ignore(300,'\n');

filterfile2 >> A2;
filterfile2.ignore(300,'\n');

filterfile2 >> A3;
filterfile2.ignore(300,'\n');

filterfile2 >> A4;
filterfile2.ignore(300,'\n');

filterfile2 >> A5;
filterfile2.ignore(300,'\n');



filterfile2.close();

/*
cout << "Writing file plotccm.gpl ...";

plotccmfile <<"set label \"A_{V}="<< AV <<" (mag) \" at "<<lambda_V*1000+25<<","<<AV+AV/25.<<" font \"Helvetica,10\""<< '\n';
plotccmfile <<"set label \"A_{U}="<< AU <<" (mag) \" at "<<lambda_U*1000+25<<","<<AU+AV/25.<<" font \"Helvetica,10\""<< '\n';
plotccmfile <<"set label \"A_{B}="<< AB <<" (mag) \" at "<<lambda_B*1000+25<<","<<AB+AV/25.<<" font \"Helvetica,10\""<< '\n';
plotccmfile <<"set label \"A_{R}="<< AR <<" (mag) \" at "<<lambda_R*1000+25<<","<<AR+AV/25.<<" font \"Helvetica,10\""<< '\n';
plotccmfile <<"set label \"A_{I}="<< AI <<" (mag) \" at "<<lambda_I*1000+25<<","<<AI+AV/25.<<" font \"Helvetica,10\""<< '\n';
plotccmfile <<"set label \"A_{J}="<< AJ <<" (mag) \" at "<<lambda_J*1000+25<<","<<AJ+AV/25.<<" font \"Helvetica,10\""<< '\n';
plotccmfile <<"set label \"A_{H}="<< AH <<" (mag) \" at "<<lambda_H*1000+25<<","<<AH+AV/25.<<" font \"Helvetica,10\""<< '\n';
plotccmfile <<"set label \"A_{K}="<< AK <<" (mag) \" at "<<lambda_K*1000+25<<","<<AK+AV/25.<<" font \"Helvetica,10\""<< '\n';



plotccmfile <<"plot 'ccmfilters.out' using 2:1 with lines lw 1.5, \"< echo "<< lambda_V*1000 <<" "<<AV<<"\" pt 7 ps 0.75,"<<"\"< echo "<< lambda_U*1000 <<" "<<AU<<"\" pt 6 ps 0.5"<< ",\"< echo "<< lambda_B*1000 <<" "<<AB<<"\" pt 6 ps 0.5"<<",\"< echo "<< lambda_R*1000 <<" "<<AR<<"\" pt 6 ps 0.5"<<",\"< echo "<< lambda_I*1000 <<" "<<AI<<"\" pt 6 ps 0.5"<<",\"< echo "<< lambda_J*1000 <<" "<<AJ<<"\" pt 6 ps 0.5"<<",\"< echo "<< lambda_H*1000 <<" "<<AH<<"\" pt 6 ps 0.5"<<",\"< echo "<< lambda_K*1000 <<" "<<AK<<"\" pt 6 ps 0.5"<<'\n';

plotccmfile.close();

cout <<"... done !" <<'\n';


cout <<"\n";
*/ 
 
 _chdir("..");

/* 
 cout <<"Writing file plotex ...";

  ofstream plotfile2("plotex");

  if (plotfile2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }
 
 plotfile2 << "cd data"<<'\n';
 plotfile2 << "echo Now plotting..."<<'\n';
 plotfile2 << "gnuplot plotccm.gpl"<<'\n';
 plotfile2 << "echo ...done !"<<'\n';
 
 
 plotfile2.close();

 cout <<"... done !" <<"\n";

 cout <<"\n";
*/



filters2 <<"A_B-A_V:  "<<AB-AV<<'\n';


filters2.close();



_chdir(".."); 


cout <<'\n';
cout <<"...all done !" <<'\n';

cout <<'\n';


 return 0;

}
