////////////////////////////////////////////////////////////////////////////////
//
//
//   Author       : Bogdan Popescu
//   Organization : University of Cincinnati
//   Program      : goking2
//   Version      : 2.014
//   Date         : Dec 10, 2014
//   Tested       : g++ 4.6.3 x64 (Ubuntu 12.04 LTS x64)
//                  g++ 4.8.2 x64 (Ubuntu 14.04 LTS x64)     
//                    
//                  
//
////////////////////////////////////////////////////////////////////////////////
//
//    MASSCLEAN (MASSive CLuster Evolution and ANalysis Package)
//    Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON
//
//    goking2.cc is part of MASSCLEAN.
//
//    MASSCLEAN is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    MASSCLEAN is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with MASSCLEAN; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//    or go to : http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////////


#include <cstdlib>
#include <ctime>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <ctype.h> 
#include <iomanip> 

#include <sys/time.h>  
#include <time.h>
#include <unistd.h>

#define NOCOLUMNS 1
#define PI 3.14159265


using namespace std;


int alllines(char *name)
{
//////////////////////
////
//// 
////

  int NOLINES;

  char oneline[400];
  NOLINES=0;

  ifstream data0;

  data0.open(name);

  if (data0.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (!data0.eof())
  {
     if (!isdigit(data0.peek()) || !isspace(data0.peek()))
	{
	    NOLINES=NOLINES+1;

            data0.getline(oneline,400,'\n');

	    if(data0.eof()) break;
	}

     if (isdigit(data0.peek()) || isspace(data0.peek()))
       {
            NOLINES=NOLINES+1;

            data0.getline(oneline,400,'\n');

            if(data0.eof()) break;
        }

   if(data0.eof()) break;
   }

  data0.close();

  return NOLINES;

}


int alldatalines(char *name, int NOLINES)
{
//////////////////////
////
//// 
////

  int i,k;

  int NODATALINES;

  double read_column;

  NODATALINES=0;

  ifstream data1;

  data1.open(name);

  if (data1.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

for (k=0;k<(NOLINES);k++)
 {
   if (isdigit(data1.peek()) || isspace(data1.peek()))
       {
       for (i=0;i<(NOCOLUMNS);i++)  
            {                      
            data1 >> read_column ;
            
            }
        NODATALINES=NODATALINES+1;

        if(data1.eof()) break;
        }

   if (!isdigit(data1.peek()) || !isspace(data1.peek()))
	  {data1.ignore(400,'\n');data1.peek(); }

 if(data1.eof()) break;
 }

  data1.close();

return NODATALINES;

}


int alldatacolumns(char *name)
{
//////////////////////
////
//// 
////

  int NOCOL;

  double col;

  NOCOL=0;

  ifstream data3;

  data3.open(name);

  if (data3.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data3.peek()=='#') {data3.ignore(400,'\n'); }

  while (1)
  {
  data3 >> col ;

  NOCOL=NOCOL+1;

  if(data3.peek()=='\n') break;

  if(data3.eof()) break;
  }

  data3.close();

 return NOCOL;

}




int datalinescolumn(char *name, int i)

{
 if (i==1) return alldatalines(name,alllines(name));
 if (i==2) return alldatacolumns(name);
}



///////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
///////////
///////////  MAIN PROGRAM
///////////
//////////////////////////////////////////////////////////////////////////////////



int main()
{


  cout << "\n";


  cout <<"MASSCLEAN 2.014 (MASSive CLuster Evolution and ANalysis Package)"<<"\n";

  cout <<"Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON,"<<"\n";

  cout <<"under GNU General Public License. For details see 'COPYING'."<<"\n";

  cout <<"The program 'goKING2' is part of MASSCLEAN 2.014 CC (Clever Crocodile)."<<"\n";

  cout << "\n";
  cout <<"http://massclean.org/"<< '\n';
  cout <<"http://bogdan.massclean.org/"<< '\n';

  cout << "\n";


  cout <<"Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  cout <<"Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  cout <<"Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';


  cout << "\n";
  cout << "\n";


  /// prototypes
  int alllines(char*);
  int alldatalines(char*,int);
  int alldatacolumns(char*);
  int datalinescolumn(char*,int);

int z,random_index1,random_index2,i,j,jj,jjj,jjjj,k;

//srand((unsigned)time(0));

////////////////////////////////////////////////////////
timeval timv;
gettimeofday(&timv, NULL);

int randomini;
randomini=timv.tv_usec;
srand(randomini);
///////////////////////////////////////////////////////


double x,y,xout,yout,theta,alpha;
double rt;
double rc;
double r_a, r_a2;
double xcenter,ycenter,rt_rescaling;
double c0,mass;
double nada;
double rotangle, ranangle1, ranangle2;
int STARNO, STARLINES, STARTOTAL;

int bubonoff,nobubbles,randombub;
double beta1,beta2;


_chdir("data"); 

// OUTPUT start

 ofstream outfile("king.out");

  if (outfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }


cout << "Reading file 'n_distribution.out'...";

STARLINES=datalinescolumn("n_distribution.out",1);



ifstream filein2;
filein2.open("n_distribution.out");
if (filein2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein2.peek()=='#') { filein2.ignore(300,'\n');}

/*
STARTOTAL=0;

for (i=0;i<STARLINES;i++)
{
filein2 >> nada;
filein2 >> STARNO;
STARTOTAL=STARTOTAL+STARNO;

}
*/

STARTOTAL=STARLINES;

cout << "...done !"<<'\n';
cout << "The total number of stars : "<< STARTOTAL <<'\n'<<'\n';

filein2.close();


cout << "Reading file 'king.ini' ...";

_chdir(".."); 


_chdir("ini.files");

  int headonoff;



  //headonoff=0;
  //headonoff=1;


  ifstream data13("header.ini");

  if (data13.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data13.peek()=='#') { data13.ignore(300,'\n');}

  data13 >> headonoff; 
  data13.ignore(300,'\n');

  data13.close();




ifstream filein;
filein.open("king.ini");
if (filein.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein.peek()=='#') { filein.ignore(300,'\n');}


filein >> xcenter; filein.ignore(300,'\n');
filein >> ycenter; filein.ignore(300,'\n');
filein >> rt_rescaling; filein.ignore(300,'\n');
filein >> rt; filein.ignore(300,'\n');
filein >> rc; filein.ignore(300,'\n');
filein >> r_a; filein.ignore(300,'\n');
filein >> r_a2; filein.ignore(300,'\n');
filein >> rotangle; filein.ignore(300,'\n');
filein >> bubonoff; filein.ignore(300,'\n');

filein >> nobubbles; filein.ignore(300,'\n');



double xbub2[nobubbles],ybub2[nobubbles],rxbub2[nobubbles],rybub2[nobubbles];
double xbub3[nobubbles],ybub3[nobubbles],rxbub3[nobubbles],rybub3[nobubbles];
double index[nobubbles];


  {
  for (j=0;j<(nobubbles);j++)
  {
  filein >> index[j]; filein.ignore(300,'\n');
  filein >> xbub3[j]; filein.ignore(300,'\n');
  filein >> ybub3[j]; filein.ignore(300,'\n');
  filein >> rxbub3[j]; filein.ignore(300,'\n');
  filein >> rybub3[j]; filein.ignore(300,'\n');

  }

filein.close();
  }





_chdir("..");

for (jj=0;jj<(nobubbles);jj++)
  {
  xbub2[jj]=xbub3[jj];
  ybub2[jj]=ybub3[jj];
  rxbub2[jj]=rxbub3[jj];
  rybub2[jj]=rybub3[jj];

  }

double xbub[nobubbles],ybub[nobubbles],rxbub[nobubbles],rybub[nobubbles];
      for (jjj=0;jjj<(nobubbles);jjj++)
          {
	  xbub[jjj]=rand()/(RAND_MAX+1.0);
	  ybub[jjj]=rand()/(RAND_MAX+1.0);
	  rxbub[jjj]=rand()/(RAND_MAX+1.0)/4.;
	  rybub[jjj]=rand()/(RAND_MAX+1.0)/4.;
	  }





cout << "...done !"<<'\n';

//cout << '\n';


double rtc,rescaling;
rtc=rt/rc;


if (((0.5-fabs(0.5-xcenter))-(0.5-fabs(0.5-ycenter)))>=0.)
{rescaling=(0.5-fabs(0.5-ycenter));}
if (((0.5-fabs(0.5-xcenter))-(0.5-fabs(0.5-ycenter)))<0.)
{rescaling=(0.5-fabs(0.5-xcenter));}



rt=rt/0.5*(rescaling)*rt_rescaling;
rc=rt/rtc;





c0=1./sqrt(1.+(rt*rt)/(rc*rc));




  cout << "Writing file 'king.out'...";

if (headonoff==1)
{
  outfile <<"##  "<< '\n';
  outfile <<"##  MASSCLEAN 2.014 Clever Crocodile"<< '\n';
  outfile <<"##  B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfile <<"##  http://massclean.org/"<< '\n';

  outfile <<"##  "<< '\n';

  outfile <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  outfile <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  outfile <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  outfile <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  outfile <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  outfile <<"##  "<< '\n';

 
  outfile <<"##  king.out "<<'\n';
  outfile <<"##  "<< '\n';
  outfile <<"##  "<<STARTOTAL<<" stars"<< '\n';
  outfile <<"##  "<< '\n';
  outfile <<"## 0<= x <=1, 0<= y <=1"<< '\n';
  outfile <<"##    x             y"<< '\n';
  outfile <<"##    1             2"<< '\n';
}



for (z=0;z<STARTOTAL;z++)
{

// KING START

random_index1 = (rand())%2;

x=1.-rand()/(RAND_MAX+1.0);

theta=rand()/(RAND_MAX+1.0);
alpha=rand()/(RAND_MAX+1.0)*2.*PI;

if (random_index1==0)
{

xout=xcenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(sin(PI*theta/2.0))*r_a*rt_rescaling;



random_index2 = (rand())%2;
if (random_index2==0)
{

yout=ycenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;



}
if (random_index2==1)
{

yout=ycenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}
}

if (random_index1==1)
{

xout=xcenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(sin(PI*theta/2.0))*r_a*rt_rescaling;



random_index2 = (rand())%2;
if (random_index2==0)
{

yout=ycenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}
if (random_index2==1)
{

yout=ycenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}

}

// KING END

// "BUBBLE"


if (bubonoff==0 || nobubbles==0)
{
xout=xout;
yout=yout;
}

else

{


for (k=0;k<(nobubbles);k++)
{

if (index[k]==100 && fabs(xout-xbub2[k])<rxbub2[k] && fabs(yout-ybub2[k])<rybub2[k] && ((xout-xbub2[k])*(xout-xbub2[k])/rxbub2[k]/rxbub2[k]+(yout-ybub2[k])*(yout-ybub2[k])/rybub2[k]/rybub2[k])<1.)
{


random_index1 = (rand())%2;

x=1.-rand()/(RAND_MAX+1.0);

theta=rand()/(RAND_MAX+1.0);
alpha=rand()/(RAND_MAX+1.0)*2.*PI;

if (random_index1==0)
{

xout=xcenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(sin(PI*theta/2.0))*r_a*rt_rescaling;



random_index2 = (rand())%2;
if (random_index2==0)
{

yout=ycenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;



}
if (random_index2==1)
{

yout=ycenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}
}

if (random_index1==1)
{

xout=xcenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(sin(PI*theta/2.0))*r_a*rt_rescaling;



random_index2 = (rand())%2;
if (random_index2==0)
{

yout=ycenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}
if (random_index2==1)
{

yout=ycenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}

}


}

// 

if (index[k]==100 && fabs(xout-xbub2[k])<rxbub2[k] && fabs(yout-ybub2[k])<rybub2[k] && ((xout-xbub2[k])*(xout-xbub2[k])/rxbub2[k]/rxbub2[k]+(yout-ybub2[k])*(yout-ybub2[k])/rybub2[k]/rybub2[k])<1.)

{



random_index1 = (rand())%2;

x=1.-rand()/(RAND_MAX+1.0);

theta=rand()/(RAND_MAX+1.0);
alpha=rand()/(RAND_MAX+1.0)*2.*PI;

if (random_index1==0)
{

xout=xcenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(sin(PI*theta/2.0))*r_a*rt_rescaling;



random_index2 = (rand())%2;
if (random_index2==0)
{

yout=ycenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;



}
if (random_index2==1)
{

yout=ycenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}
}

if (random_index1==1)
{

xout=xcenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(sin(PI*theta/2.0))*r_a*rt_rescaling;



random_index2 = (rand())%2;
if (random_index2==0)
{

yout=ycenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}
if (random_index2==1)
{

yout=ycenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}

}


} 

if ((index[k]==200 && fabs(xout-xbub2[k])<rxbub2[k] && fabs(yout-ybub2[k])<rybub2[k]) && (-rybub2[k]/(rxbub2[k]*rxbub2[k])*(fabs(xout-xbub2[k])-rxbub2[k])*(fabs(xout-xbub2[k])-rxbub2[k])+ybub2[k]-(yout)<0.) && (+rybub2[k]/(rxbub2[k]*rxbub2[k])*(fabs(xout-xbub2[k])-rxbub2[k])*(fabs(xout-xbub2[k])-rxbub2[k])+ybub2[k]-(yout)>0.))
{


random_index1 = (rand())%2;

x=1.-rand()/(RAND_MAX+1.0);

theta=rand()/(RAND_MAX+1.0);
alpha=rand()/(RAND_MAX+1.0)*2.*PI;

if (random_index1==0)
{

xout=xcenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(sin(PI*theta/2.0))*r_a*rt_rescaling;



random_index2 = (rand())%2;
if (random_index2==0)
{

yout=ycenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;



}
if (random_index2==1)
{

yout=ycenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}
}

if (random_index1==1)
{

xout=xcenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(sin(PI*theta/2.0))*r_a*rt_rescaling;



random_index2 = (rand())%2;
if (random_index2==0)
{

yout=ycenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}
if (random_index2==1)
{

yout=ycenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}

}



if ((index[k]==200 && fabs(xout-xbub2[k])<rxbub2[k] && fabs(yout-ybub2[k])<rybub2[k]) && (-rybub2[k]/(rxbub2[k]*rxbub2[k])*(fabs(xout-xbub2[k])-rxbub2[k])*(fabs(xout-xbub2[k])-rxbub2[k])+ybub2[k]-(yout)<0.) && (+rybub2[k]/(rxbub2[k]*rxbub2[k])*(fabs(xout-xbub2[k])-rxbub2[k])*(fabs(xout-xbub2[k])-rxbub2[k])+ybub2[k]-(yout)>0.))
{



random_index1 = (rand())%2;

x=1.-rand()/(RAND_MAX+1.0);

theta=rand()/(RAND_MAX+1.0);
alpha=rand()/(RAND_MAX+1.0)*2.*PI;

if (random_index1==0)
{

xout=xcenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(sin(PI*theta/2.0))*r_a*rt_rescaling;



random_index2 = (rand())%2;
if (random_index2==0)
{

yout=ycenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;



}
if (random_index2==1)
{

yout=ycenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}
}

if (random_index1==1)
{

xout=xcenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(sin(PI*theta/2.0))*r_a*rt_rescaling;



random_index2 = (rand())%2;
if (random_index2==0)
{

yout=ycenter+(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}
if (random_index2==1)
{

yout=ycenter-(rescaling)*rc/rt*sqrt(-1./((-c0*c0-2*x*c0+x*c0*c0+x)*(-c0*c0-2*x*c0+x*c0*c0+x))*(-c0*c0+c0*c0*c0*c0-x+x*x-3.*x*c0*c0+4.*c0*c0*c0*x-2.*c0*c0*c0*c0*x-4.*x*x*c0+6.*x*x*c0*c0-4.*x*x*c0*c0*c0+x*x*c0*c0*c0*c0+2.*x*c0+2.*sqrt(-2.*c0*c0*c0*x+c0*c0*c0*c0*x+x*c0*c0)))*fabs(cos(PI*theta/2.0))*r_a2*rt_rescaling;


}

}



}

} 
else
{
xout=xout;
yout=yout;
}



}

} // k loop








/// OUTPUT




outfile.setf(ios::fixed,ios::floatfield);  
outfile.precision(8);

if (rotangle==0.0)
{
outfile<< setw(12) << xout;
outfile <<"  "<< setw(12) << yout << '\n';
}

else 
{

ranangle1=acos((xout-xcenter)/sqrt((xout-xcenter)*(xout-xcenter)+(yout-ycenter)*(yout-ycenter)));
ranangle2=asin((yout-ycenter)/sqrt((xout-xcenter)*(xout-xcenter)+(yout-ycenter)*(yout-ycenter)));


     if ((xout>=xcenter) && (yout>=ycenter))
     {
     outfile<< setw(12) << xcenter+ sqrt((xout-xcenter)*(xout-xcenter)+(yout-ycenter)*(yout-ycenter))*cos(ranangle1+rotangle*PI/180.);
     outfile <<"  "<< setw(12) << ycenter + sqrt((xout-xcenter)*(xout-xcenter)+(yout-ycenter)*(yout-ycenter))*sin(ranangle2+rotangle*PI/180.) << '\n';
     }

     if ((xout<xcenter) && (yout<ycenter))
     {
     outfile<< setw(12) << xcenter- sqrt((xout-xcenter)*(xout-xcenter)+(yout-ycenter)*(yout-ycenter))*cos(fabs(ranangle2)+rotangle*PI/180.);
     outfile <<"  "<< setw(12) << ycenter - sqrt((xout-xcenter)*(xout-xcenter)+(yout-ycenter)*(yout-ycenter))*sin(fabs(ranangle2)+rotangle*PI/180.) << '\n';
     }

     if ((xout>=xcenter) && (yout<ycenter))
     {
     outfile<< setw(12) << xcenter+ sqrt((xout-xcenter)*(xout-xcenter)+(yout-ycenter)*(yout-ycenter))*cos(fabs(ranangle1)-rotangle*PI/180.);
     outfile <<"  "<< setw(12) << ycenter - sqrt((xout-xcenter)*(xout-xcenter)+(yout-ycenter)*(yout-ycenter))*sin(fabs(ranangle2)-rotangle*PI/180.) << '\n';
     }

     if ((xout<xcenter) && (yout>=ycenter))
     {
     outfile<< setw(12) << xcenter- sqrt((xout-xcenter)*(xout-xcenter)+(yout-ycenter)*(yout-ycenter))*cos(fabs(ranangle2)-rotangle*PI/180.);
     outfile <<"  "<< setw(12) << ycenter + sqrt((xout-xcenter)*(xout-xcenter)+(yout-ycenter)*(yout-ycenter))*sin(fabs(ranangle2)-rotangle*PI/180.) << '\n';
     }



}





///OUTPUT END

// END z loop
}

outfile.close();

cout << "... done ! \n";
//cout << "\n";

/*
_chdir("data");
 
  cout <<"Writing file 'king.gpl' ...";

  ofstream plotfile("king.gpl");

  if (plotfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }

 plotfile <<"set terminal postscript enhanced"<< '\n';
 plotfile <<"set output 'king.eps'"<< '\n';

 plotfile <<"set size square"<< '\n';
 
 plotfile <<"set nokey"<< '\n';

 plotfile <<"set xrange [0:1]"<< '\n';
 
 plotfile <<"set yrange [0:1]"<< '\n';
 
 plotfile <<"set label \"r_{c}="<< rc <<", r_{t}="<< rt << "\" at 0.025,0.025 font \"Helvetica,12\""<< '\n';

 plotfile <<"plot 'king.out' with points pt 7 ps 0.3"<< '\n';

 plotfile.close();

 cout <<"... done !" <<"\n";

 cout <<"\n";

 _chdir("..");
*/

/*
  cout <<"Writing file 'plotking' ...";

  ofstream plotfile2("plotking");

  if (plotfile2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }
 
 plotfile2 << "cd data"<<'\n';
 plotfile2 << "echo Now plotting..."<<'\n';
 plotfile2 << "gnuplot king.gpl"<<'\n';
 plotfile2 << "echo ...done !"<<'\n';
 
 
 plotfile2.close();

 cout <<"... done !" <<"\n";

 cout <<"\n";

*/

_chdir("data"); 



cout <<"Writing file 'n_distribution.out2' ...";


 ofstream outfile2("n_distribution.out2");

  if (outfile2.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }

if (headonoff==1)
{

  outfile2 <<"##  "<< '\n';
  outfile2 <<"##  MASSCLEAN 2.014 Clever Crocodile"<< '\n';
  outfile2 <<"##  B.Popescu and M.M.Hanson, 2007-2014 "<< '\n';
  outfile2 <<"##  http://massclean.org/"<< '\n';

  outfile2 <<"##  "<< '\n';

  outfile2 <<"##  Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  outfile2 <<"##  Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  outfile2 <<"##  Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';

  outfile2 <<"##  "<< '\n';

  
  outfile2 <<"#   n_distribution.out2"<< '\n';
  outfile2 <<"#"<< '\n';

  outfile2.precision(2);
//  outfile2 <<"#   The total mass : "<<Mtotal<<" M_Sun"<< '\n';
  outfile2 <<"#   King model : r_c/r_t="<<rc/rt<< '\n';

  
  outfile2 <<"#"<< '\n';
}


ifstream filein3;
filein3.open("n_distribution.out");
if (filein3.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein3.peek()=='#') { filein3.ignore(300,'\n');}


ifstream filein4;
filein4.open("king.out");
if (filein4.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein4.peek()=='#') { filein4.ignore(300,'\n');}


int p;
double massfile,unu,ml1,ml2;
double xfile,yfile;

outfile2.setf(ios::fixed,ios::floatfield); 

for (p=0;p<STARTOTAL;p++)
  {
  filein3 >> massfile; 
  filein3.ignore(300,'\n');

  filein4 >> xfile; 
  filein4 >> yfile;
  filein4.ignore(300,'\n');




  outfile2.precision(10);
  outfile2<< setw(14)  <<massfile<<" "<< setw(8)<<"1"<<"   ";

  outfile2.precision(8);
  outfile2<< setw(12) << xfile;
  outfile2<<"  "<< setw(12) << yfile;
  

  outfile2<<'\n'; 

  }












_chdir(".."); 

 cout <<"... done !" <<"\n";

 cout <<"\n";


cout <<"... all done !" <<"\n";

cout <<'\n';




return 0;
}

