////////////////////////////////////////////////////////////////////////////////
//
//
//   Author       : Bogdan Popescu
//   Organization : University of Cincinnati
//   Program      : gogauss
//   Version      : 2.014
//   Date         : Dec 10, 2014
//   Tested       : g++ 4.6.3 x64 (Ubuntu 12.04 LTS x64)
//                  g++ 4.8.2 x64 (Ubuntu 14.04 LTS x64)     
//                    
//                  
//
////////////////////////////////////////////////////////////////////////////////
//
//    MASSCLEAN (MASSive CLuster Evolution and ANalysis Package)
//    Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON
//
//    gogauss.cc is part of MASSCLEAN.
//
//    MASSCLEAN is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    MASSCLEAN is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with MASSCLEAN; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//    or go to : http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////////



#include <iostream>
#include <fstream>
#include <stdio.h>
#include <math.h>
#include <ctype.h> 
#include <iomanip> 
#include <stdlib.h> 

#include <sys/time.h>  
#include <time.h>
#include <unistd.h>



#define NOCOLUMNS 1

#define PI 3.14159265


using namespace std;



int alllines(char *name)
{
//////////////////////
////
//// 
////

  int NOLINES;

  char oneline[500];
  NOLINES=0;

  ifstream data0;

  data0.open(name);

  if (data0.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (!data0.eof())
  {
     if (!isdigit(data0.peek()) || !isspace(data0.peek()))
	{
	    NOLINES=NOLINES+1;

            data0.getline(oneline,500,'\n');

	    if(data0.eof()) break;
	}

     if (isdigit(data0.peek()) || isspace(data0.peek()))
       {
            NOLINES=NOLINES+1;

            data0.getline(oneline,500,'\n');

            if(data0.eof()) break;
        }

   if(data0.eof()) break;
   }

  data0.close();

  return NOLINES;

}


int alldatalines(char *name, int NOLINES)
{
//////////////////////
////
//// 
////

  int i,k;

  int NODATALINES;

  double read_column;

  NODATALINES=0;

  ifstream data1;

  data1.open(name);

  if (data1.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

for (k=0;k<(NOLINES);k++)
 {
   if (isdigit(data1.peek()) || isspace(data1.peek()))
       {
       for (i=0;i<(NOCOLUMNS);i++)  
            {                      
            data1 >> read_column ;
           
            }
        NODATALINES=NODATALINES+1;

        if(data1.eof()) break;
        }

   if (!isdigit(data1.peek()) || !isspace(data1.peek()))
	  {data1.ignore(500,'\n');data1.peek(); }

 if(data1.eof()) break;
 }

  data1.close();

return NODATALINES;

}


int alldatacolumns(char *name)
{
//////////////////////
////
//// 
////

  int NOCOL;

  double col;

  NOCOL=0;

  ifstream data3;

  data3.open(name);

  if (data3.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

  while (data3.peek()=='#') {data3.ignore(500,'\n'); }

  while (1)
  {
  data3 >> col ;

  NOCOL=NOCOL+1;

  if(data3.peek()=='\n') break;

  if(data3.eof()) break;
  }

  data3.close();

 return NOCOL;

}


int datalinescolumn(char *name, int i)

{
 if (i==1) return alldatalines(name,alllines(name));
 if (i==2) return alldatacolumns(name);
}



///////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
///////////
///////////  MAIN PROGRAM
///////////
//////////////////////////////////////////////////////////////////////////////////

int main()
{
  cout << "\n";


  cout <<"MASSCLEAN 2.014 (MASSive CLuster Evolution and ANalysis Package)"<<"\n";

  cout <<"Copyright (C) 2007-2014 BOGDAN POPESCU and MARGARET HANSON,"<<"\n";

  cout <<"under GNU General Public License. For details see 'COPYING'."<<"\n";

  cout <<"The program 'goGAUSS' is part of MASSCLEAN 2.014 CC (Clever Crocodile)."<<"\n";

  cout << "\n";
  cout <<"http://massclean.org/"<< '\n';
  cout <<"http://bogdan.massclean.org/"<< '\n';

  cout << "\n";


  cout <<"Popescu & Hanson 2009, AJ, 138, 1724"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJL, 713, L21"<< '\n';
  cout <<"Popescu & Hanson 2010, ApJ, 724, 296"<< '\n';
  cout <<"Popescu, Hanson & Elmegreen 2012, ApJ, 751, 122"<< '\n';
  cout <<"Popescu & Hanson 2014, ApJ, 780, 27"<< '\n';


  cout << "\n";
  cout << "\n";



  /// prototypes
  int alllines(char*);
  int alldatalines(char*,int);
  int alldatacolumns(char*);
  int datalinescolumn(char*,int);


//  srand((unsigned)time(0));

////////////////////////////////////////////////////////
timeval timv;
gettimeofday(&timv, NULL);

int randomini;
randomini=timv.tv_usec;
srand(randomini);
///////////////////////////////////////////////////////


//outfile.setf(ios::fixed,ios::floatfield); 


  int NOSTARS;

  _chdir(".."); // utility
  _chdir(".."); // MAIN
  _chdir("data"); // data

  NOSTARS=datalinescolumn("n_distribution.out",1);
 
  cout<<NOSTARS<<'\n';  

ifstream filein;
filein.open("n_distribution.out");
if (filein.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;
  }

while (filein.peek()=='#') { filein.ignore(300,'\n');}


  _chdir(".."); // MAIN
  _chdir("utility"); // utility
  _chdir("widecmd"); // widecmd

double mass;


 ofstream outfile("mass-gauss.txt");

  if (outfile.bad())
  {
  cerr << "Error ! "<<'\n';
  return 1 ;

  }

outfile.setf(ios::fixed,ios::floatfield);

int i;


  double U, V, S;

  double X, Y;

  double U2,V2,U3,V3,U4,V4,U5,V5,U6,V6,U7,V7,U8,V8,U9,V9,U10,V10,U11,V11,U12,V12,U13,V13,U14,V14;
  double X2,Y2,X3,Y3,X4,Y4,X5,Y5,X6,Y6,X7,Y7,X8,Y8,X9,Y9,X10,Y10,X11,Y11,X12,Y12,X13,Y13,X14,Y14;


for (i=0;i<NOSTARS;i++)
{

filein>> mass;
filein.ignore(300,'\n');



while (1)
{
  U=rand()/(RAND_MAX+1.0);
  V=rand()/(RAND_MAX+1.0);
 
  X=sqrt(-2.*log(U))*sin(2*PI*V);
  Y=sqrt(-2.*log(U))*cos(2*PI*V);

  if ((X>=-4.) && (X<=4.) && (Y>=-4.) && (Y<=4.)) {break;}

}


while (1)
{
  U2=rand()/(RAND_MAX+1.0);
  V2=rand()/(RAND_MAX+1.0);
 
  X2=sqrt(-2.*log(U2))*sin(2*PI*V2);
  Y2=sqrt(-2.*log(U2))*cos(2*PI*V2);

  if ((X2>=-4.) && (X2<=4.) && (Y2>=-4.) && (Y2<=4.)) {break;}

}

while (1)
{
  U3=rand()/(RAND_MAX+1.0);
  V3=rand()/(RAND_MAX+1.0);
 
  X3=sqrt(-2.*log(U3))*sin(2*PI*V3);
  Y3=sqrt(-2.*log(U3))*cos(2*PI*V3);

  if ((X3>=-4.) && (X3<=4.) && (Y3>=-4.) && (Y3<=4.)) {break;}

}

while (1)
{
  U4=rand()/(RAND_MAX+1.0);
  V4=rand()/(RAND_MAX+1.0);
 
  X4=sqrt(-2.*log(U4))*sin(2*PI*V4);
  Y4=sqrt(-2.*log(U4))*cos(2*PI*V4);

  if ((X4>=-4.) && (X4<=4.) && (Y4>=-4.) && (Y4<=4.)) {break;}

}

while (1)
{
  U5=rand()/(RAND_MAX+1.0);
  V5=rand()/(RAND_MAX+1.0);
 
  X5=sqrt(-2.*log(U5))*sin(2*PI*V5);
  Y5=sqrt(-2.*log(U5))*cos(2*PI*V5);

  if ((X5>=-4.) && (X5<=4.) && (Y5>=-4.) && (Y5<=4.)) {break;}

}

while (1)
{
  U6=rand()/(RAND_MAX+1.0);
  V6=rand()/(RAND_MAX+1.0);
 
  X6=sqrt(-2.*log(U6))*sin(2*PI*V6);
  Y6=sqrt(-2.*log(U6))*cos(2*PI*V6);

  if ((X6>=-4.) && (X6<=4.) && (Y6>=-4.) && (Y6<=4.)) {break;}

}

while (1)
{
  U7=rand()/(RAND_MAX+1.0);
  V7=rand()/(RAND_MAX+1.0);
 
  X7=sqrt(-2.*log(U7))*sin(2*PI*V7);
  Y7=sqrt(-2.*log(U7))*cos(2*PI*V7);

  if ((X7>=-4.) && (X7<=4.) && (Y7>=-4.) && (Y7<=4.)) {break;}

}




//cout<<X<<'\n';

outfile.precision(10);

outfile<< setw(16)<< mass<<"  ";
outfile<< setw(14)<< X/4. <<"  ";
outfile<< setw(14)<< Y/4. <<"  ";

outfile<< setw(14)<< X2/4. <<"  ";
outfile<< setw(14)<< Y2/4. <<"  ";

outfile<< setw(14)<< X3/4. <<"  ";
outfile<< setw(14)<< Y3/4. <<"  ";

outfile<< setw(14)<< X4/4. <<"  ";
outfile<< setw(14)<< Y4/4. <<"  ";

outfile<< setw(14)<< X5/4. <<"  ";
outfile<< setw(14)<< Y5/4. <<"  ";

outfile<< setw(14)<< X6/4. <<"  ";
outfile<< setw(14)<< Y6/4. <<"  ";

outfile<< setw(14)<< X7/4. <<"  ";
//outfile<< setw(14)<< Y7/4. <<"  ";



outfile <<'\n';



} // i loop

cout <<"... all done !" <<'\n';

cout <<'\n';



 return 0;

}

